<!--
#
# This software may be used and distributed according to the terms
# of the GNU Public License, incorporated herein by reference.
#
# See file COPYING for details of the GNU GPL.
#
#################################
WebNap Client copyright 2000
Aakash Kambuj - aakash@idearing.com
Kalpak Kothari - kalpak@idearing.com
#################################

You are welcome to modify and distribute this code, but you MUST retain
this copyright notice above any notices you put.  If you use this program
beyond personal use, we request that you send us a copy of your modified code.

Napster is a registered trademark of Napster Inc - http://www.napster.com
-->

<?

include("webnap.inc");

$message_type_login = 2;
$message_type_login_response = 3;
$message_type_sysmsg = 621;
$message_type_search = 200;
$message_type_search_result = 201;
$message_type_search_complete = 202;
$message_type_fileinfo_req = 203;
$message_type_fileinfo = 204;
$message_type_get_error = 206;
$message_type_stats = 214;
$server_to_use= "";
// $server_socket=0;


function init_conn($napserver){

  global $server_socket;
  global $message_type_login;
  global $message_type_login_response;
  global $message_type_sysmsg;
  global $mesage_type_stats;
  global $server_to_use;
  global $username;
  global $password;
  global $keywords;

  $server= "";
  if (!isset($server_socket)){
    $server_socket=0;
     //$server_socket=2;

  }

  $already_connected = $server_socket;
   //  echo "Connection status is $already_connected <br>";
  if ($already_connected<=0){
    $host = $napserver;
    $server_to_use=$napserver;
    $port = 8888;

     //now we know the hostname and port to connect to
     //    echo "Connecting to server $host:$port<br>";
    $server_socket = fsockopen($host, $port, &$errstr, &$errno);     //open a persistent connection to the server
    if (!$server_socket){
      echo  "ERROR $errstr ($errno)<br>\n";
      exit;
    }

     //    echo "Connected: server_socket is  $server_socket <br>";

     //now we can send a login packet

     // please use your own username/password pair here
    $login_string =  "$username $password 6699 \"nap v0.8\" 10";

    $len = strlen($login_string);
    $login_packet = pack( "vv", $len, $message_type_login);
    $login_packet = $login_packet . $login_string;

    fwrite($server_socket, $login_packet);

    $buffer = read_packet();

    $last =  "";

    echo "\n\n<table width=100%><tr><td width=55%>\n";
    echo "<table><tr><td>\n";
    print_search_form();
    echo "</td></tr></table>\n\n";
    echo "</td>\n";
    echo "<td width=45%><center><table bgcolor=\"#eeeef8\" border=1 cellspacing=0>\n";
    echo "<tr><td><center>Message of the Day</center><font size=-2>\n";
    do {
      $buffer = read_packet();
      echo  " $last ";
      $last = $buffer[2];

    } while ((int)$buffer[1]==$message_type_sysmsg);

     // the last line of the system message usually has the server stats
    printstats($buffer[2]);

    echo  "</font></td></tr></table></center>\n\n";
    echo "</td></tr></table>\n\n";
  }
}

function cmp_speed ($a, $b) {
  if ($a->conn_speed == $b->conn_speed) return 0;
  return ($a->conn_speed > $b->conn_speed) ? -1 : 1;
}

function searchmp3($keywords) {

  global $server_socket;


  $songs = find_song($keywords);
  flush();
  if (is_string($songs)) {
    echo "Your search returned 0 songs.";
  }
  else {
  $numsongs = count($songs);
  echo  "Your search returned $numsongs songs.";

   //now $songs contains the list of songs we have

  echo "<TABLE width=\"100%\" border=0 cellspacing=0 cellpadding=2><tr bgcolor=\"737b9c\"><td>Hit it!</td><td>Filename</td><td>Nick</td><td>Size</td><td>Bitrate</td><td>Frequency</td><td>Time</td><td>Speed</td></tr>\n";

  for ($i=0;$i<$numsongs;$i++){
    $songlist[$i] = new Song;
    $songlist[$i]->init_song($songs[$i]);
  }
   // sort
  usort($songlist, cmp_speed);

  // print songs with alternate row colors
  $j=0;
  for($i=0;$i<$numsongs;$i++){
    if($j==0) {
      print("<tr bgcolor=\"#eeeef8\">");
      $songlist[$i]->print_song();
    }
    else {
      print("<tr bgcolor=\"#ffffff\">");
      $songlist[$i]->print_song();
    }
    $j = !$j;
  }

  print( "</table>");
  }
  fclose($server_socket);


}

function getmp3($songid){

  global  $server_socket;
  global $QUERY_STRING;
  global $keywords;

   //we have already logged in. The find song code can then be called
   //repeatedly

   //First check the connection to the server

  if ($server_socket<=0){
    echo  "ERROR. Connection failed!";
  }

  $songinfo = urldecode( "$songid");

  if ($QUERY_STRING != "") {
   $songinfo = unserialize(stripslashes($songinfo));
  }
  else {
    $songinfo = unserialize($songinfo);
  }

  $curr_song = new Song;
  $curr_song->unpack_data($songinfo);
  $curr_song->download_song();

   //    fclose($server_socket);  //remove this after development is done
}


function find_song($keywords){

  global $message_type_search;
  global $message_type_search_complete;
  global $message_type_search_result;

  $find_str =  "FILENAME CONTAINS \"";
  $find_str .= $keywords;
  $find_str .=  "\" MAX_RESULTS 100";

  write_packet($message_type_search, $find_str);

  $songs[0]= "";
  $search_done = FALSE;
  $i=0;

  do {

    $search_result = read_packet();

    switch ($search_result[1]) {

    case $message_type_search_complete:
      $search_done = TRUE;
      break;

    case $message_type_search_result:
      $songs[$i]=trim($search_result[2]);
      $i++;
      break;

    default:
      break;

    }  //end of switch

  } while (!$search_done);

  if ($i == 0)
    return "";
  else return $songs;

}



function write_packet($m_type, $m_mesg){


  global $server_socket;


  $pkt_len = strlen($m_mesg);

  $packet = pack( "vv",$pkt_len, $m_type);

  $packet = $packet . $m_mesg;

  fwrite($server_socket, $packet);


}



function read_packet() {

  global $server_socket;

  $data_array= "";

  $buf = fread($server_socket, 4);
  $buf1 = unpack( "v2vals",$buf);
  $len1 = $buf1[ "vals1"];
  $msg_type1 = $buf1[ "vals2"];

   //  echo "<br> len1 is $len1  messagetype is $msg_type1 ";

  if ($len1 <=0 ) {
     //    echo " EMPTY PACKET->";
     //    echo "<br>";

    $data_array[0] = $len1;
    $data_array[1] = $msg_type1;
    $data_array[2] =  "";
  }
  else {

    $data = fread($server_socket, $len1);

    $data_array[0] = $len1;
    $data_array[1] = $msg_type1;
    $data_array[2] = $data;
  }

  return $data_array;

}

function printstats($stats){
  list($users, $files, $size) = explode( " ", $stats);
  echo  "<br>Server Stats: $users users logged in, $files files available,
$size Gb total library size <br>";
}


function uinttoip($hostname){

  $flag=0;
  $storage = $hostname;
  $temp = (double) $hostname;
  $temp = $temp - 2147483648.0;
  $hostname = (int)$temp;
  if ($hostname < 0 ){
    $hostname = (int) $storage;
  }
  else $flag=1;

  $dig4 = ($hostname & 2130706432) >> 24;

  if ($flag == 1)
    $dig4 += 128;

  $dig3 = ($hostname & 16711680) >> 16;
  $dig2 = ($hostname & 65280) >> 8;
  $dig1 = $hostname & 255;

   //  echo "<br> dig1 is $dig1  dig2 is $dig2  dig3 is $dig3  dig4 is $dig4<br>";

  $hname = (string) $dig1;
  $hname = $hname .  ".";
  $hname = $hname . (string)$dig2;
  $hname = $hname .  ".";
  $hname = $hname . (string)$dig3;
  $hname = $hname .  ".";
  $hname = $hname . (string)$dig4;

  return (string)$hname;

}

function addheader($type){
  global $version;

  switch($type) {
  case 0:
    echo  "<html>";
    echo  "<title>$version</title>";
    echo  "<body bgcolor=white>";
    echo  "<center><font face=Arial size=6>$version</font><br><i>Now with
Form support!</i>";
    echo  "<hr noshade size=1></center>";
    echo  "<br><b>Debug version running</b><br>";
    break;
  case 1:
    echo  "<html>";
    echo  "<title>$version</title>";
    echo  "<body bgcolor=white>";
    echo  "<center><font face=Arial size=6>$version</font><br><i>Now with
Form support!</i>";
    echo  "<hr noshade size=1></center>";
    break;
  default:
    echo  "<html>";
    echo  "<title>$version</title>";
    echo  "<body bgcolor=white>";
    echo  "<center><h1>$version</h1><br><i>Now with Form support!</i>";
    echo  "<hr noshade size=1></center>";
    echo  "<br><b>Debug version running</b><br>";
    break;
  }
}

  function print_speed($a) {
    // pretty-print connection speed
    switch($a) {
    case 0:
      return "??";
      break;
    case 1:
      return "14.4K";
      break;
    case 2:
      return "28.8K";
      break;
    case 3:
      return "33.6K";
      break;
    case 4:
      return "56K";
      break;
    case 5:
      return "64K";
      break;
    case 6:
      return "128K";
      break;
    case 7:
      return "Cable";
      break;
    case 8:
      return "DSL";
      break;
    case 9:
      return "T1";
      break;
    case 10:
      return "T3";
      break;
    default:
      return "??";
      break;
    }
  }



class Song {

  var $data=array();
  var $user= "";
  var $title= "";
  var $filename= "";
  var $checksum= "";
  var $size=0;
  var $bitrate=0;
  var $frequency=0;
  var $time=0;
  var $nick= "";
  var $nick_ip= "";
  var $conn_speed =0;

  function init_song($str){

     //first, get the pathname of the song

    for ($i=(strlen($str)-1);$i>=0 && strcmp($str[$i], '"')!=0;$i--);

    $this->title = substr($str,0,$i+1);

    $this->data[ "title"]=substr($str,0,$i+1);
    $index = $i;
     //now get song name

    for ($i=(strlen($this->title)-1);$i>=0 && strcmp($str[$i], '\\')!=0;$i--);


    if ($i==-1){
      $this->filename = $this->title;
      //      echo  "file1-> $this->filename<br>";
      $this->data[ "filename"] = $this->title;
    }
    else {
      $temp = substr($this->title, $i+1);
      $this->filename = substr($temp, 0, strlen($temp)-1);
      $this->data[ "filename"] = $this->filename;
    }

    $info = substr($str, $index+2);

    $tok = strtok($info, " ");

    $this->checksum = $tok;
    $this->data[ "checksum"] = $tok;

    for ($i=0;$i<7;$i++){
      $tok = strtok( " ");

      switch($i){

      case 0:
    $this->size = (int)$tok;
    $this->data[ "size"] = (int)$tok;
    break;

      case 1:
    $this->bitrate = (int)$tok;
    $this->data[ "bitrate"]=(int)$tok;
    break;

      case 2:
    $this->frequency = (int)$tok;
    $this->data[ "frequency"]=(int)$tok;
    break;

      case 3:
	//    $this->time = (int)$tok;
	$this->time = (int)(((int)$tok)/60) . ":" . sprintf("%02d", ((int)$tok)%60);
    $this->data[ "time"]=(int)$tok;
    break;

      case 4:
    $this->nick = $tok;
    $this->data[ "nick"]=$tok;
    break;

      case 5:
    $this->nick_ip = $tok;
    $this->data[ "nick_ip"]=$tok;
    break;

      case 6:
    $this->conn_speed = (int)$tok;
    $this->data[ "conn_speed"]=(int)$tok;
    break;

      default:
    break;
      }
    }

  }


  function print_song() {

    global $server_socket;
    global $server_to_use;
    global $username;
    global $password;
    global $keywords;

//    print("<tr>");

    $stream = urlencode(serialize($this->data));
    print("<form method=POST action=searchmp3.php>");
    print("<input type=hidden name=napserver value=\"$server_to_use\">");
    print("<input type=hidden name=username value=\"$username\">");
    print("<input type=hidden name=password value=\"$password\">");
    print("<input type=hidden name=songid value=\"$stream\">");
    print("<input type=hidden name=keywords value=\"$keywords\">");
    print("<td><input type=submit value='Get!'></td>");
    print("</form>\n");
    print ( "<td><a href=\"searchmp3.php?napserver=$server_to_use&username=$username&password=$password&songid=$stream&keywords=$keywords\">$this->filename</a></td>");
    print(  "<td>$this->nick </td>");
    print(  "<td>$this->size </td>");
    print(  "<td>$this->bitrate </td>");
    print(  "<td>$this->frequency </td>");
    print(  "<td>$this->time </td>");
    echo "<td>" . print_speed($this->conn_speed) . "</td>";
    print(  "</tr>\n");
    flush();
  }


  function unpack_data($datum){


    $this->data = $datum;

    $this->data[ "title"] = $datum[ "title"];
    $this->title = $datum[ "title"];

    $this->data[ "filename"] = $datum[ "filename"];
    $this->filename = $datum[ "filename"];

    $this->data[ "checksum"] = $datum[ "checksum"];
    $this->checksum = $datum[ "checksum"];

    $this->data[ "size"] = $datum[ "size"];
    $this->size = $datum[ "size"];

    $this->data[ "bitrate"] = $datum[ "bitrate"];
    $this->bitrate = $datum[ "bitrate"];

    $this->data[ "frequency"] = $datum[ "frequency"];
    $this->frequency = $datum[ "frequency"];

    $this->data[ "time"] = $datum[ "time"];
    $this->time = $datum[ "time"];

    $this->data[ "nick"] = $datum[ "nick"];
    $this->nick = $datum[ "nick"];

    $this->data[ "nick_ip"] = $datum[ "nick_ip"];
    $this->nick_ip = $datum[ "nick_ip"];


    $this->data[ "conn_speed"] = $datum[ "conn_speed"];
    $this->conn_speed = $datum[ "conn_speed"];

  }


  function download_song() {

    global $server_socket;
    global $message_type_fileinfo_req;
    global $message_type_fileinfo;
    global $message_type_get_error;
    global $username;

     //send message to server
    $message =  "$this->nick  ";
    $message .=  "$this->title";

    write_packet($message_type_fileinfo_req, $message);

    $answer = "";

    flush();

    $answer = read_packet();

    if((int)$answer[1]==$message_type_get_error) {
      print( "<br> Download Error. The remote file you requested to download is unavailable.<br>");
      flush();
      return;
    }
    elseif((int)$answer[1]==$message_type_stats) {
      print( "<br> Server replied back with stats.<br>");
      printstats($answer[2]);
      print( "<br>Try your query again.<br>");
    }
    elseif((int)$answer[1]!=$message_type_fileinfo) {
       // return if we did not receive download ack
      print( "<br> Download Error. Did not receive download ACK.<br>");
      flush();
      return;
    }

     /****
    while(((int)$answer[1]!=$message_type_fileinfo) or ((int)$answer[1]!=$message_type_get_error)){ //  or
      $answer = read_packet();
      if((int)$answer[1]==$message_type_stats) {
    printstats($answer[2]);
      }
      //      print("<br>The server replied $answer[1] $answer[2]<br>");
      flush();
    }

    if((int)$answer[1]==$message_type_get_error) {
      print("<br> Download Error. The remote file you requested to download is unavailable.<br>");
      flush();
      return;
    }
    ***/

     // server returns the download ack
    $ruser = strtok($answer[2],  " ");
    $rhost = strtok( " ");
    $rport = strtok( " ");


     //Convert the $rhost to quad dotted ip address format

    $rhost = uinttoip($rhost);
    flush();

    echo  "Remote Host is $rhost <br>";
    echo  "Remote Port is $rport";

    if ($rport != 0) {
      $title_withoutquotes = rawurlencode($this->title);
      $filename_withoutquotes = rawurlencode($this->filename);

      echo "<center>Note: Download works fine with Netscape, but IE may choke.<br>";
      echo  "<br><center><a href=\"download.php?username=$username&rhost=$rhost&rport=$rport&title=$title_withoutquotes&filename=$filename_withoutquotes\">Download song</a></center><br>";

      echo "<br>Or try alternative method using forms<br>\n";
      echo  "<br><center><form method=POST action=download.php><input type=hidden name=username value=$username><input type=hidden name=rhost value=$rhost><input type=hidden name=rport value=$rport><input type=hidden name=title value=$title_withoutquotes><input type=hidden name=filename value=$filename_withoutquotes><input type=submit value='Download Song'></form></center><br>";
      


      fclose($server_socket);  // we are still unable to use just one socket. this keeps the number of open sockets low.
    }
    else {
      echo  "<br><br><font size=3><b>Remote user is behind a firewall. Download option from such users is yet to be implemented.</font></br>";

      fclose($server_socket);
    }
  }

}

// make sure that socket is closed when script ends (normal or "user abort")
register_shutdown_function( "close_conn");

function close_conn(){
  global $server_socket;
  if ($server_socket>0) {
    fclose($server_socket);
  }
}


?>

<?
if (isset($songid)){
  addheader(1);
  init_conn($napserver);
  getmp3($songid);
}
else {
  if (isset($keywords)){
    addheader(1);
    echo  "<center><font size=\"+3\">Searching for \"$keywords\" on
$napserver.</font><br><br></center>";
    init_conn($napserver);
    searchmp3($keywords);
  }
}
?>

</body></html>
